"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var time_duration_picker_component_1 = require("./time-duration-picker.component");
var TimeDurationPickerUnitComponent = (function () {
    function TimeDurationPickerUnitComponent(timeDurationPicker) {
        this.timeDurationPicker = timeDurationPicker;
        this.onChange = new core_1.EventEmitter();
        this.value = 0;
    }
    TimeDurationPickerUnitComponent.prototype.ngOnInit = function () {
        this.name = this.name.toLocaleLowerCase();
        var supportedUnitsNames = Object.keys(this.timeDurationPicker.supportedUnits);
        if (supportedUnitsNames.indexOf(this.name) === -1) {
            throw new Error('Unsupported unit: ' + this.name);
        }
        if (this.label == null) {
            this.label = this.name.charAt(0).toUpperCase() + this.name.slice(1);
        }
        if (this.step == null) {
            this.step = 1;
        }
        if (this.timeDurationPicker.inputDisabled != null) {
            this.inputDisabled = this.timeDurationPicker.inputDisabled;
        }
        if (this.inputDisabled == null) {
            this.inputDisabled = true;
        }
        if (this.min == null) {
            this.min = this.timeDurationPicker.supportedUnits[this.name].min;
        }
        if (this.max == null) {
            this.max = this.timeDurationPicker.supportedUnits[this.name].max;
        }
    };
    TimeDurationPickerUnitComponent.prototype.increaseValue = function () {
        var currentValue = this.value;
        if (currentValue < this.max) {
            currentValue = currentValue + this.step;
        }
        else {
            currentValue = this.min;
        }
        this.value = currentValue;
        this.updateValue();
    };
    TimeDurationPickerUnitComponent.prototype.decreaseValue = function () {
        var currentValue = this.value;
        if (currentValue > this.min) {
            currentValue = currentValue - this.step;
        }
        else {
            currentValue = this.max;
        }
        this.value = currentValue;
        this.updateValue();
    };
    TimeDurationPickerUnitComponent.prototype.checkValue = function (event) {
        var currentValue = event.target.value;
        if (currentValue < this.min) {
            currentValue = this.min;
        }
        else if (currentValue > this.max) {
            currentValue = this.max;
        }
        if (currentValue !== parseInt(currentValue)) {
            currentValue = Math.round(currentValue);
        }
        event.target.value = currentValue;
        this.updateValue();
    };
    TimeDurationPickerUnitComponent.prototype.updateValue = function () {
        this.onChange.emit(this.getValue());
        this.timeDurationPicker.updateValue();
    };
    TimeDurationPickerUnitComponent.prototype.getValue = function () {
        return this.value;
    };
    return TimeDurationPickerUnitComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TimeDurationPickerUnitComponent.prototype, "name", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", String)
], TimeDurationPickerUnitComponent.prototype, "label", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], TimeDurationPickerUnitComponent.prototype, "max", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], TimeDurationPickerUnitComponent.prototype, "min", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Number)
], TimeDurationPickerUnitComponent.prototype, "step", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TimeDurationPickerUnitComponent.prototype, "inputDisabled", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TimeDurationPickerUnitComponent.prototype, "onChange", void 0);
TimeDurationPickerUnitComponent = __decorate([
    core_1.Component({
        selector: 'time-duration-picker-unit',
        template: "\n\t<div class=\"form-group\">\n\t\t<table>\n\t\t\t<tbody>\n\t\t\t\t<tr class=\"text-center\">\n\t\t\t\t\t<td>\n\t\t\t\t\t\t<button type=\"button\" (click)=\"increaseValue()\" class=\"btn btn-link\">\n\t\t\t\t\t\t\t+\n\t\t\t\t\t\t</button>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"text-center\">\n\t\t\t\t\t<td class=\"input-group input-group-sm\">\n\t\t\t\t\t\t<input [(ngModel)]=\"value\" [disabled]=\"inputDisabled\" class=\"form-control text-center\" style=\"width:42px;\"\n\t\t\t\t\t\t(blur)=\"checkValue($event)\" type=\"number\" min=\"{{min}}\" max=\"{{max}}\"/>  \n\t\t\t\t\t\t<span class=\"input-group-addon\" style=\"padding: 5px;\">{{label}}</span>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t\t<tr class=\"text-center\">\n\t\t\t\t\t<td>\n\t\t\t\t\t\t<button type=\"button\" (click)=\"decreaseValue()\" class=\"btn btn-link\">\n\t\t\t\t\t\t-\n\t\t\t\t\t\t</button>\n\t\t\t\t\t</td>\n\t\t\t\t</tr>\n\t\t\t</tbody>\n\t\t</table>\n\t</div>\n  ",
        styles: ["\n    input[type=number]::-webkit-inner-spin-button,\n    input[type=number]::-webkit-outer-spin-button {\n      -webkit-appearance: none;\n      margin: 0; \n    }\n    input[type=number] {\n      text-align: center;\n    }\n  "]
    }),
    __param(0, core_1.Host()), __param(0, core_1.Inject(core_1.forwardRef(function () { return time_duration_picker_component_1.TimeDurationPickerComponent; }))),
    __metadata("design:paramtypes", [time_duration_picker_component_1.TimeDurationPickerComponent])
], TimeDurationPickerUnitComponent);
exports.TimeDurationPickerUnitComponent = TimeDurationPickerUnitComponent;
//# sourceMappingURL=time-duration-picker-unit.component.js.map