"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var time_duration_picker_unit_component_1 = require("./time-duration-picker-unit.component");
var TimeDurationPickerComponent = (function () {
    function TimeDurationPickerComponent() {
        this.supportedUnits = {
            millisecond: {
                'label': 'Millisecond',
                'max': 999,
                'min': 0,
                'value': 0,
                'step': 1
            },
            second: {
                'label': 'Second',
                'max': 59,
                'min': 0,
                'value': 0,
                'step': 1
            },
            minute: {
                'label': 'Minute',
                'max': 59,
                'min': 0,
                'value': 0,
                'step': 1
            },
            hour: {
                'label': 'Hour',
                'max': 23,
                'min': 0,
                'value': 0,
                'step': 1
            },
            day: {
                'label': 'Day',
                'max': 7,
                'min': 0,
                'value': 0,
                'step': 1
            },
            week: {
                'label': 'Week',
                'max': 51,
                'min': 0,
                'value': 0,
                'step': 1
            }
        };
        this.convert = {
            'week': {
                'week': 1,
                'day': 7,
                'hour': 168,
                'minute': 10080,
                'second': 604800,
                'millisecond': 604800000
            },
            'day': {
                'week': 0.041666666666666664,
                'day': 1,
                'hour': 24,
                'minute': 1440,
                'second': 86400,
                'millisecond': 86400000
            },
            'hour': {
                'week': 0.0006944444444444445,
                'day': 0.016666666666666666,
                'hour': 1,
                'minute': 60,
                'second': 3600,
                'millisecond': 3600000
            },
            'minute': {
                'week': 0.000011574074074074073,
                'day': 0.0002777777777777778,
                'hour': 0.016666666666666666,
                'minute': 1,
                'second': 60,
                'millisecond': 60000
            },
            'second': {
                'week': 1.1574074074074076e-8,
                'day': 2.777777777777778e-7,
                'hour': 0.000016666666666666667,
                'minute': 0.001,
                'second': 1,
                'millisecond': 1000
            },
            'millisecond': {
                'week': 1.1574074074074076e-8,
                'day': 2.777777777777778e-7,
                'hour': 0.000016666666666666667,
                'minute': 0.001,
                'second': 1,
                'millisecond': 1
            }
        };
        this.onChange = new core_1.EventEmitter();
    }
    TimeDurationPickerComponent.prototype.ngAfterContentInit = function () {
        if (!this.returnedValueUnit) {
            this.returnedValueUnit = 'second';
        }
        this.returnedValueUnit = this.returnedValueUnit.trim().toLowerCase();
        if (this.inputDisabled == null) {
            this.inputDisabled = true;
        }
    };
    TimeDurationPickerComponent.prototype.updateValue = function () {
        this.onChange.emit(this.getValue());
    };
    TimeDurationPickerComponent.prototype.getValue = function () {
        var _this = this;
        var value = 0;
        this.units.toArray().forEach(function (element) {
            value += _this.convert[element.name.toLocaleLowerCase()][_this.returnedValueUnit] * element.getValue();
        });
        return value;
    };
    return TimeDurationPickerComponent;
}());
__decorate([
    core_1.Input(),
    __metadata("design:type", Object)
], TimeDurationPickerComponent.prototype, "returnedValueUnit", void 0);
__decorate([
    core_1.Input(),
    __metadata("design:type", Boolean)
], TimeDurationPickerComponent.prototype, "inputDisabled", void 0);
__decorate([
    core_1.Output(),
    __metadata("design:type", core_1.EventEmitter)
], TimeDurationPickerComponent.prototype, "onChange", void 0);
__decorate([
    core_1.ContentChildren(core_1.forwardRef(function () { return time_duration_picker_unit_component_1.TimeDurationPickerUnitComponent; })),
    __metadata("design:type", core_1.QueryList)
], TimeDurationPickerComponent.prototype, "units", void 0);
TimeDurationPickerComponent = __decorate([
    core_1.Component({
        selector: 'time-duration-picker',
        template: "\n\t<ng-content></ng-content>\n  ",
        styles: []
    }),
    __metadata("design:paramtypes", [])
], TimeDurationPickerComponent);
exports.TimeDurationPickerComponent = TimeDurationPickerComponent;
//# sourceMappingURL=time-duration-picker.component.js.map